/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Request to apply configuration to an existing tenant project.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ApplyTenantProjectConfigRequest extends com.google.api.client.json.GenericJson {

  /**
   * Configuration that should be applied to the existing tenant project.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TenantProjectConfig projectConfig;

  /**
   * Tag of the project. Must be less than 128 characters. Required.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tag;

  /**
   * Configuration that should be applied to the existing tenant project.
   * @return value or {@code null} for none
   */
  public TenantProjectConfig getProjectConfig() {
    return projectConfig;
  }

  /**
   * Configuration that should be applied to the existing tenant project.
   * @param projectConfig projectConfig or {@code null} for none
   */
  public ApplyTenantProjectConfigRequest setProjectConfig(TenantProjectConfig projectConfig) {
    this.projectConfig = projectConfig;
    return this;
  }

  /**
   * Tag of the project. Must be less than 128 characters. Required.
   * @return value or {@code null} for none
   */
  public java.lang.String getTag() {
    return tag;
  }

  /**
   * Tag of the project. Must be less than 128 characters. Required.
   * @param tag tag or {@code null} for none
   */
  public ApplyTenantProjectConfigRequest setTag(java.lang.String tag) {
    this.tag = tag;
    return this;
  }

  @Override
  public ApplyTenantProjectConfigRequest set(String fieldName, Object value) {
    return (ApplyTenantProjectConfigRequest) super.set(fieldName, value);
  }

  @Override
  public ApplyTenantProjectConfigRequest clone() {
    return (ApplyTenantProjectConfigRequest) super.clone();
  }

}
