/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Request to attach an existing project to the tenancy unit as a new tenant resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AttachTenantProjectRequest extends com.google.api.client.json.GenericJson {

  /**
   * When attaching an external project, this is in the format of `projects/{project_number}`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String externalResource;

  /**
   * When attaching a reserved project already in tenancy units, this is the tag of a tenant
   * resource under the tenancy unit for the managed service's service producer project. The
   * reserved tenant resource must be in an active state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String reservedResource;

  /**
   * Tag of the tenant resource after attachment. Must be less than 128 characters. Required.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tag;

  /**
   * When attaching an external project, this is in the format of `projects/{project_number}`.
   * @return value or {@code null} for none
   */
  public java.lang.String getExternalResource() {
    return externalResource;
  }

  /**
   * When attaching an external project, this is in the format of `projects/{project_number}`.
   * @param externalResource externalResource or {@code null} for none
   */
  public AttachTenantProjectRequest setExternalResource(java.lang.String externalResource) {
    this.externalResource = externalResource;
    return this;
  }

  /**
   * When attaching a reserved project already in tenancy units, this is the tag of a tenant
   * resource under the tenancy unit for the managed service's service producer project. The
   * reserved tenant resource must be in an active state.
   * @return value or {@code null} for none
   */
  public java.lang.String getReservedResource() {
    return reservedResource;
  }

  /**
   * When attaching a reserved project already in tenancy units, this is the tag of a tenant
   * resource under the tenancy unit for the managed service's service producer project. The
   * reserved tenant resource must be in an active state.
   * @param reservedResource reservedResource or {@code null} for none
   */
  public AttachTenantProjectRequest setReservedResource(java.lang.String reservedResource) {
    this.reservedResource = reservedResource;
    return this;
  }

  /**
   * Tag of the tenant resource after attachment. Must be less than 128 characters. Required.
   * @return value or {@code null} for none
   */
  public java.lang.String getTag() {
    return tag;
  }

  /**
   * Tag of the tenant resource after attachment. Must be less than 128 characters. Required.
   * @param tag tag or {@code null} for none
   */
  public AttachTenantProjectRequest setTag(java.lang.String tag) {
    this.tag = tag;
    return this;
  }

  @Override
  public AttachTenantProjectRequest set(String fieldName, Object value) {
    return (AttachTenantProjectRequest) super.set(fieldName, value);
  }

  @Override
  public AttachTenantProjectRequest clone() {
    return (AttachTenantProjectRequest) super.clone();
  }

}
