/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Describes the billing configuration for a new tenant project.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BillingConfig extends com.google.api.client.json.GenericJson {

  /**
   * Name of the billing account. For example `billingAccounts/012345-567890-ABCDEF`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String billingAccount;

  /**
   * Name of the billing account. For example `billingAccounts/012345-567890-ABCDEF`.
   * @return value or {@code null} for none
   */
  public java.lang.String getBillingAccount() {
    return billingAccount;
  }

  /**
   * Name of the billing account. For example `billingAccounts/012345-567890-ABCDEF`.
   * @param billingAccount billingAccount or {@code null} for none
   */
  public BillingConfig setBillingAccount(java.lang.String billingAccount) {
    this.billingAccount = billingAccount;
    return this;
  }

  @Override
  public BillingConfig set(String fieldName, Object value) {
    return (BillingConfig) super.set(fieldName, value);
  }

  @Override
  public BillingConfig clone() {
    return (BillingConfig) super.clone();
  }

}
