/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Request to create a tenancy unit for a service consumer of a managed service.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CreateTenancyUnitRequest extends com.google.api.client.json.GenericJson {

  /**
   * Optional service producer-provided identifier of the tenancy unit. Must be no longer than 40
   * characters and preferably URI friendly. If it isn't provided, a UID for the tenancy unit is
   * automatically generated. The identifier must be unique across a managed service. If the tenancy
   * unit already exists for the managed service and service consumer pair, calling
   * `CreateTenancyUnit` returns the existing tenancy unit if the provided identifier is identical
   * or empty, otherwise the call fails.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tenancyUnitId;

  /**
   * Optional service producer-provided identifier of the tenancy unit. Must be no longer than 40
   * characters and preferably URI friendly. If it isn't provided, a UID for the tenancy unit is
   * automatically generated. The identifier must be unique across a managed service. If the tenancy
   * unit already exists for the managed service and service consumer pair, calling
   * `CreateTenancyUnit` returns the existing tenancy unit if the provided identifier is identical
   * or empty, otherwise the call fails.
   * @return value or {@code null} for none
   */
  public java.lang.String getTenancyUnitId() {
    return tenancyUnitId;
  }

  /**
   * Optional service producer-provided identifier of the tenancy unit. Must be no longer than 40
   * characters and preferably URI friendly. If it isn't provided, a UID for the tenancy unit is
   * automatically generated. The identifier must be unique across a managed service. If the tenancy
   * unit already exists for the managed service and service consumer pair, calling
   * `CreateTenancyUnit` returns the existing tenancy unit if the provided identifier is identical
   * or empty, otherwise the call fails.
   * @param tenancyUnitId tenancyUnitId or {@code null} for none
   */
  public CreateTenancyUnitRequest setTenancyUnitId(java.lang.String tenancyUnitId) {
    this.tenancyUnitId = tenancyUnitId;
    return this;
  }

  @Override
  public CreateTenancyUnitRequest set(String fieldName, Object value) {
    return (CreateTenancyUnitRequest) super.set(fieldName, value);
  }

  @Override
  public CreateTenancyUnitRequest clone() {
    return (CreateTenancyUnitRequest) super.clone();
  }

}
