/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Translates to IAM Policy bindings (without auditing at this level)
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PolicyBinding extends com.google.api.client.json.GenericJson {

  /**
   * Uses the same format as in IAM policy. `member` must include both a prefix and ID. For example,
   * `user:{emailId}`, `serviceAccount:{emailId}`, `group:{emailId}`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> members;

  /**
   * Role. (https://cloud.google.com/iam/docs/understanding-roles) For example, `roles/viewer`,
   * `roles/editor`, or `roles/owner`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String role;

  /**
   * Uses the same format as in IAM policy. `member` must include both a prefix and ID. For example,
   * `user:{emailId}`, `serviceAccount:{emailId}`, `group:{emailId}`.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getMembers() {
    return members;
  }

  /**
   * Uses the same format as in IAM policy. `member` must include both a prefix and ID. For example,
   * `user:{emailId}`, `serviceAccount:{emailId}`, `group:{emailId}`.
   * @param members members or {@code null} for none
   */
  public PolicyBinding setMembers(java.util.List<java.lang.String> members) {
    this.members = members;
    return this;
  }

  /**
   * Role. (https://cloud.google.com/iam/docs/understanding-roles) For example, `roles/viewer`,
   * `roles/editor`, or `roles/owner`.
   * @return value or {@code null} for none
   */
  public java.lang.String getRole() {
    return role;
  }

  /**
   * Role. (https://cloud.google.com/iam/docs/understanding-roles) For example, `roles/viewer`,
   * `roles/editor`, or `roles/owner`.
   * @param role role or {@code null} for none
   */
  public PolicyBinding setRole(java.lang.String role) {
    this.role = role;
    return this;
  }

  @Override
  public PolicyBinding set(String fieldName, Object value) {
    return (PolicyBinding) super.set(fieldName, value);
  }

  @Override
  public PolicyBinding clone() {
    return (PolicyBinding) super.clone();
  }

}
