/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * The per-product per-project service identity for a service.
 *
 * Use this field to configure per-product per-project service identity. Example of a service
 * identity configuration.
 *
 *     usage:       service_identity:       - service_account_parent: "projects/123456789"
 * display_name: "Cloud XXX Service Agent"         description: "Used as the identity of Cloud XXX
 * to access resources"
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ServiceIdentity extends com.google.api.client.json.GenericJson {

  /**
   * Optional. A user-specified opaque description of the service account. Must be less than or
   * equal to 256 UTF-8 bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Optional. A user-specified name for the service account. Must be less than or equal to 100
   * UTF-8 bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * A service account project that hosts the service accounts.
   *
   * An example name would be: `projects/123456789`
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String serviceAccountParent;

  /**
   * Optional. A user-specified opaque description of the service account. Must be less than or
   * equal to 256 UTF-8 bytes.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. A user-specified opaque description of the service account. Must be less than or
   * equal to 256 UTF-8 bytes.
   * @param description description or {@code null} for none
   */
  public ServiceIdentity setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Optional. A user-specified name for the service account. Must be less than or equal to 100
   * UTF-8 bytes.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Optional. A user-specified name for the service account. Must be less than or equal to 100
   * UTF-8 bytes.
   * @param displayName displayName or {@code null} for none
   */
  public ServiceIdentity setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * A service account project that hosts the service accounts.
   *
   * An example name would be: `projects/123456789`
   * @return value or {@code null} for none
   */
  public java.lang.String getServiceAccountParent() {
    return serviceAccountParent;
  }

  /**
   * A service account project that hosts the service accounts.
   *
   * An example name would be: `projects/123456789`
   * @param serviceAccountParent serviceAccountParent or {@code null} for none
   */
  public ServiceIdentity setServiceAccountParent(java.lang.String serviceAccountParent) {
    this.serviceAccountParent = serviceAccountParent;
    return this;
  }

  @Override
  public ServiceIdentity set(String fieldName, Object value) {
    return (ServiceIdentity) super.set(fieldName, value);
  }

  @Override
  public ServiceIdentity clone() {
    return (ServiceIdentity) super.clone();
  }

}
