/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Representation of a tenancy unit.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TenancyUnit extends com.google.api.client.json.GenericJson {

  /**
   * @OutputOnly Cloud resource name of the consumer of this service. For example 'projects/123456'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String consumer;

  /**
   * @OutputOnly The time this tenancy unit was created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String createTime;

  /**
   * Globally unique identifier of this tenancy unit "services/{service}/{collection id}/{resource
   * id}/tenancyUnits/{unit}"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Output only. Google Cloud API name of the managed service owning this tenancy unit. For example
   * 'serviceconsumermanagement.googleapis.com'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String service;

  /**
   * Resources constituting the tenancy unit. There can be at most 512 tenant resources in a tenancy
   * unit.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<TenantResource> tenantResources;

  static {
    // hack to force ProGuard to consider TenantResource used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(TenantResource.class);
  }

  /**
   * @OutputOnly Cloud resource name of the consumer of this service. For example 'projects/123456'.
   * @return value or {@code null} for none
   */
  public java.lang.String getConsumer() {
    return consumer;
  }

  /**
   * @OutputOnly Cloud resource name of the consumer of this service. For example 'projects/123456'.
   * @param consumer consumer or {@code null} for none
   */
  public TenancyUnit setConsumer(java.lang.String consumer) {
    this.consumer = consumer;
    return this;
  }

  /**
   * @OutputOnly The time this tenancy unit was created.
   * @return value or {@code null} for none
   */
  public String getCreateTime() {
    return createTime;
  }

  /**
   * @OutputOnly The time this tenancy unit was created.
   * @param createTime createTime or {@code null} for none
   */
  public TenancyUnit setCreateTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

  /**
   * Globally unique identifier of this tenancy unit "services/{service}/{collection id}/{resource
   * id}/tenancyUnits/{unit}"
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Globally unique identifier of this tenancy unit "services/{service}/{collection id}/{resource
   * id}/tenancyUnits/{unit}"
   * @param name name or {@code null} for none
   */
  public TenancyUnit setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Output only. Google Cloud API name of the managed service owning this tenancy unit. For example
   * 'serviceconsumermanagement.googleapis.com'.
   * @return value or {@code null} for none
   */
  public java.lang.String getService() {
    return service;
  }

  /**
   * Output only. Google Cloud API name of the managed service owning this tenancy unit. For example
   * 'serviceconsumermanagement.googleapis.com'.
   * @param service service or {@code null} for none
   */
  public TenancyUnit setService(java.lang.String service) {
    this.service = service;
    return this;
  }

  /**
   * Resources constituting the tenancy unit. There can be at most 512 tenant resources in a tenancy
   * unit.
   * @return value or {@code null} for none
   */
  public java.util.List<TenantResource> getTenantResources() {
    return tenantResources;
  }

  /**
   * Resources constituting the tenancy unit. There can be at most 512 tenant resources in a tenancy
   * unit.
   * @param tenantResources tenantResources or {@code null} for none
   */
  public TenancyUnit setTenantResources(java.util.List<TenantResource> tenantResources) {
    this.tenantResources = tenantResources;
    return this;
  }

  @Override
  public TenancyUnit set(String fieldName, Object value) {
    return (TenancyUnit) super.set(fieldName, value);
  }

  @Override
  public TenancyUnit clone() {
    return (TenancyUnit) super.clone();
  }

}
