/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Resource constituting the TenancyUnit.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TenantResource extends com.google.api.client.json.GenericJson {

  /**
   * @OutputOnly Identifier of the tenant resource. For cloud projects, it is in the form
   * 'projects/{number}'. For example 'projects/123456'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String resource;

  /**
   * Status of tenant resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Unique per single tenancy unit.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tag;

  /**
   * @OutputOnly Identifier of the tenant resource. For cloud projects, it is in the form
   * 'projects/{number}'. For example 'projects/123456'.
   * @return value or {@code null} for none
   */
  public java.lang.String getResource() {
    return resource;
  }

  /**
   * @OutputOnly Identifier of the tenant resource. For cloud projects, it is in the form
   * 'projects/{number}'. For example 'projects/123456'.
   * @param resource resource or {@code null} for none
   */
  public TenantResource setResource(java.lang.String resource) {
    this.resource = resource;
    return this;
  }

  /**
   * Status of tenant resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of tenant resource.
   * @param status status or {@code null} for none
   */
  public TenantResource setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * Unique per single tenancy unit.
   * @return value or {@code null} for none
   */
  public java.lang.String getTag() {
    return tag;
  }

  /**
   * Unique per single tenancy unit.
   * @param tag tag or {@code null} for none
   */
  public TenantResource setTag(java.lang.String tag) {
    this.tag = tag;
    return this;
  }

  @Override
  public TenantResource set(String fieldName, Object value) {
    return (TenantResource) super.set(fieldName, value);
  }

  @Override
  public TenantResource clone() {
    return (TenantResource) super.clone();
  }

}
