/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-28 at 16:27:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.serviceconsumermanagement.v1.model;

/**
 * Response message for ImportProducerOverrides
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Service Consumer Management API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class V1Beta1ImportProducerOverridesResponse extends com.google.api.client.json.GenericJson {

  /**
   * The overrides that were created from the imported data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<V1Beta1QuotaOverride> overrides;

  static {
    // hack to force ProGuard to consider V1Beta1QuotaOverride used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(V1Beta1QuotaOverride.class);
  }

  /**
   * The overrides that were created from the imported data.
   * @return value or {@code null} for none
   */
  public java.util.List<V1Beta1QuotaOverride> getOverrides() {
    return overrides;
  }

  /**
   * The overrides that were created from the imported data.
   * @param overrides overrides or {@code null} for none
   */
  public V1Beta1ImportProducerOverridesResponse setOverrides(java.util.List<V1Beta1QuotaOverride> overrides) {
    this.overrides = overrides;
    return this;
  }

  @Override
  public V1Beta1ImportProducerOverridesResponse set(String fieldName, Object value) {
    return (V1Beta1ImportProducerOverridesResponse) super.set(fieldName, value);
  }

  @Override
  public V1Beta1ImportProducerOverridesResponse clone() {
    return (V1Beta1ImportProducerOverridesResponse) super.clone();
  }

}
